################################################################################
# SCRPanel Version 1.0.0
# http://www.srcpanel.webs.com/
# Free to use, free to download.
# Copyright: All rights go to www.srcpanel.webs.com/
# Plugin Coder: Matty<3
################################################################################
# Patch 1.0.1 Review
# Try to smooth script best as possible.
# Add more features
#
# Contact below:
# Sponsor: www.zeekzone.webs.com
################################################################################

from __future__ import with_statement
from path import path
from configobj import ConfigObj

import es
import cfglib
import re
import gamethread
import os
import usermsg
import string
import urllib2
import datetime



srcpanel_info = es.AddonInfo()

srcpanel_info.author      = "ZZMatty"
srcpanel_info.name        = "SRCPanel"
srcpanel_info.description = "Advanced control panel for your server."
srcpanel_info.basename    = "srcpanel"
srcpanel_info.version     = "v1.0.1"
srcpanel_info.url         = "http://www.srcspanel.webs.com/"
srcpanel_info.cfgpath     = "my_srcpanel.cfg"

srcpanel_new_version = "v1.2"
input_date = str(datetime.date.today())

es.makepublic(srcpanel_info.basename)

es.ServerVar('srcpanel', srcpanel_info.version, 'SRCPanel - Made by %s '%srcpanel_info.author).makepublic()

srcpanel_sm_admin_path = path(es.ServerVar('eventscripts_gamedir')).joinpath('addons', 'sourcemod', 'configs', 'admins_simple.ini')
copy_steamid = re.compile(r'STEAM\_\d\:\d\:\d+')

def update_version():
    global srcpanel_new_version
    try:
      srcpanel_hook = urllib2.urlopen('http://srcpanel.webs.com/update')
      version = srcpanel_hook.readlines()
      srcpanel_hook.close()
      if srcpanel_new_version in version:
           es.dbgmsg(1, "[%s] - [SRCPanel] UPDATE: New version available (v1.2)" %input_date)
           es.dbgmsg(1, "[%s] - [SRCPanel] UPDATE: Download it at: http://srcpanel.webs.com/downloads" %input_date)
           redirect_log_succes = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_update.log','w')
           redirect_log_succes.write("[%s] - [SRCPanel] UPDATE: Download it at: http://srcpanel.webs.com/downloads" %input_date)
           redirect_log_succes.write("[%s] - [SRCPanel] UPDATE: New version available (v1.2)" %input_date)
           return(version)
      else:
         srcpanel_log_succes()
         es.dbgmsg(1, "[%s] - [SRCPanel] Succesfull: checked for updates, but no updates are available!" %input_date)

    except urllib2.URLError:
        srcpanel_log_error()


def srcpanel_log_error():
      srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_error.log','w')
      srcpanel_log_error.write('[%s] - [SRCPanel] ERROR: Couldn\'t check for updates!\n[SRCPanel] ERROR: Please check if there a new update to fix this' %input_date)


def srcpanel_log_succes():
      srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_succes.log','w')
      srcpanel_log_error.write("[%s] - [SRCPanel] Succesfull: checked for updates, but no updates are available!" %input_date)


def srcpanel_log_security_settings():
    if srcpanel_debug == 1:
     if srcpanel_secure_password or srcpanel_secure_sv_cheats == 1:
      srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_security_settings.log','w')
      srcpanel_log_error.write("[%s] - [SRCPanel] security loaded, your server should be fine" %input_date)
     if srcpanel_secure_sv_cheats == 0:
      srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_security_settings.log','w')
      srcpanel_log_error.write("[%s] - [SRCPanel] WARNING some of your security settings is disabled please go configure!" %input_date)

def srcpanel_log_performence():
    if srcpanel_debug == 1:
     if srcpanel_improve_performence == 1:
      srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_performence.log','w')
      srcpanel_log_error.write("[%s] - [SRCPanel] performence was loaded and are active, your server should be lag free and run smooth." %input_date)
     if srcpanel_improve_performence == 0:
      srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_tickrate_auto.log','w')
      srcpanel_log_error.write("[%s] - [SRCPanel] WARNING you don't have improve performence set to 1 please go configurations/my_srcpanel.cfg to change!! ." %input_date)

def srcpanel_log_tickrate_auto():
      if srcpanel_debug == 1:
       srcpanel_log_error = open(es.getAddonPath(srcpanel_info.basename)+'/srcpanel_user_log/srcpanel_tickrate_auto.log','w')
       srcpanel_log_error.write("[%s] - [SRCPanel] Tickrate is currently set to %s" % (input_date, srcpanel_tickrate))

def SMAdmins():
	with srcpanel_sm_admin_path.open() as f:
		return copy_steamid.findall(f.read())


srcpanel_config = cfglib.AddonCFG(es.getAddonPath(srcpanel_info.basename)+'/configurations/my_srcpanel.cfg')

srcpanel_config.text("Welcome to the first configuration file of SRCPanel, to secure your server.")
srcpanel_config.text("Please read these few lines before you get started")
srcpanel_config.text("To enable and disable features read below:")
srcpanel_config.text("1 = (Enabled), 2 = (Admins), 0 = (Disabled)")
srcpanel_config.text("What is tickrate?")
srcpanel_config.text("Tickrate is to make it simple how good your server runs")
srcpanel_config.text("If you don't know what tickrate your server is leave it default.")
srcpanel_config.text("")

srcpanel_config.text("=================== FEATURED ======================")
srcpanel_improve_performence = srcpanel_config.cvar("srcpanel_improve_performence", "1", "This will improve your servers performence and it will run better with less lag and much more. (0 = Disabled 1 = Enable)")
srcpanel_tickrate = srcpanel_config.cvar("srcpanel_tickrate", "66", "Please write the tickrate of your server, if you don't know keep it as default. (Tickrates: 100, 66, 33)")
srcpanel_player_information = srcpanel_config.cvar("srcpanel_player_information", "1", "This will display information about players who join your server such as STEAM ID etc.. (0 = Disabled 1 = Enable)")
srcpanel_secure_password = srcpanel_config.cvar("srcpanel_secure_password", "1", "This will secure that the server can never have password enabled and will always be none, if you have CW/PCW server, we recommend you to set it '0' to disable")
srcpanel_secure_sv_cheats = srcpanel_config.cvar("srcpanel_secure_sv_cheats", "1", "This will secure that the server can never have sv_cheats 1 enabled and will always be 0 no matter what! (0 = Disabled 1 = Enable)")
srcpanel_chat_error_fix = srcpanel_config.cvar("srcpanel_chat_error_fix", "1", "This will fix chat errors like double display of 'timeleft', 'rank' etc.. (0 = Disabled 1 = Enable)")
srcpanel_server_error_fix = srcpanel_config.cvar("srcpanel_server_error_fix", "1", "This will attempt to fix server erros on your server (0 = Disabled 1 = Enable)")
srcpanel_debug = srcpanel_config.cvar("srcpanel_debug", "0", "This will enable SRCPanel debugging (0 = Disabled 1 = Enable)")

srcpanel_config.text("============== ADDONS (EXTRA) ======================")
srcpanel_config.text("You need SourceMod on your server if you want to enable Only-Admins on some of the features, it will auto detect admins")
srcpanel_bunnyjump_settings = srcpanel_config.cvar("srcpanel_bunnyjump_settings", "1", "This will enable that people can bunny jump on your server (Settings and etc) (0 = Disabled 1 = Enable)")
srcpanel_bunnyjump_increase = srcpanel_config.cvar("srcpanel_bunnyjump_increase", "1", "This will do that people can increase their current speed when bunny-jumping good for bhop, mg etc.. (0 = Disabled, 1 = Enable, 2 = Only-Admins)")

srcpanel_config.write()

srcpanel_datetime = str(datetime.date.today())


def load():
    es.makepublic(srcpanel_info.basename)
    protect_sv_cheats()
    protect_sv_password()
    srcpanel_config.execute()
    update_version()
    srcpanel_log_performence()
    srcpanel_log_security_settings()
    srcpanel_log_tickrate_auto()
    server_tickrate()
    srcpanel_public_msg('has been succesfully loaded. Your server should be running SRCPanel now. Please do not load it from in-game.')
    es.addons.registerSayFilter(sayFilter)

def unload():
    es.addons.unregisterSayFilter(sayFilter)
    srcpanel_public_msg('has been succesfully unloaded. Your server do not run SRCPanel now. ')

def srcpanel_server_performence_66():
      es.server.cmd("sv_client_cmdrate_difference 1")
      es.server.cmd("sv_client_predict 1")
      es.server.cmd("sv_client_interpolate 1")
      es.server.cmd("sv_client_min_interp_ratio -1")
      es.server.cmd("sv_client_max_interp_ratio -1")
      es.server.cmd("sv_maxupdaterate 101")
      es.server.cmd("sv_minupdaterate 100")
      es.server.cmd("sv_minrate 30000")
      es.server.cmd("sv_maxrate 0")
      es.server.cmd("sv_mincmdrate 100")
      es.server.cmd("sv_maxcmdrate 101")


def srcpanel_server_performence_33():
    if srcpanel_improve_performence == "33":
      es.server.cmd("sv_client_cmdrate_difference 1")
      es.server.cmd("sv_client_predict 1")
      es.server.cmd("sv_client_interpolate 1")
      es.server.cmd("sv_client_min_interp_ratio -1")
      es.server.cmd("sv_client_max_interp_ratio -1")
      es.server.cmd("sv_maxupdaterate 67")
      es.server.cmd("sv_minupdaterate 66")
      es.server.cmd("sv_minrate 30000")
      es.server.cmd("sv_maxrate 0")
      es.server.cmd("sv_mincmdrate 66")
      es.server.cmd("sv_maxcmdrate 67")

srcpanel_classic_fix = ["thetime", "rtv", "rockthevote", "nominate", "nextmap", "timeleft", "votekick", "voteban", "ff", "rank"]

def sayFilter(userid, text, teamonly):
    if userid == -1:
        return (userid, text, teamonly)

    text = string.strip(text, '"')
    if text.lower() in srcpanel_classic_fix:
        return (0,0,0)

    return (userid, text, teamonly)

def server_tickrate():
    if srcpanel_tickrate == "66":
      srcpanel_server_performence_66()
    if srcpanel_tickrate == "33":
      srcpanel_serverperformence_33()


def srcpanel_public_msg(text):
    es.msg('#multi', '#default[SRC#greenPanel#default]#green ' + text)


def player_activate(ev):
    steamid = ev["es_steamid"]
    name =  ev["es_username"]
    userid = ev["userid"]
    protect_sv_cheats()
    protect_sv_password()
    server_tickrate()
    if srcpanel_player_information == "1":
     if not steamid in SMAdmins():
      srcpanel_public_msg('Player: #default%s #greenwith #default[%s] #greenhas joined the server! '% (name, steamid))
     if steamid in SMAdmins():
      srcpanel_public_msg('Admin: #default%s #greenwith #default[%s] #greenhas joined the server! '% (name, steamid))


def player_say(ev):
     if ev['text']:
      protect_sv_cheats()
      protect_sv_password()
     if ev['text'] == 'bhop':
      usermsg.hudhint(event_var['userid'],"Bunnyjump increase: Your speed will increase when you jump")


def player_spawn(ev):
    protect_sv_cheats()
    protect_sv_password()
    server_tickrate()


def player_jump(ev):
   steamid = ev["es_steamid"]
   name =  ev["es_username"]
   userid = ev["userid"]
   msg = "Test Killer"
   es.usermsg("create","disp","KeyHintText")
   es.usermsg("write","byte","disp",1)
   es.usermsg("write","string","disp",msg)
   es.usermsg("send","disp",ev['attacker'])
   es.usermsg("delete","disp")
   if srcpanel_bunnyjump_increase == 2:
    if steamid in SMAdmins():
     bunnyjump_increasesize = 0.2
     vec1 = es.getplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecVelocity[0]')
     vec2 = es.getplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecVelocity[1]')
     vec1 = (bunnyjump_increasesize * vec1) * (1 / 5.1)
     vec2 = (bunnyjump_increasesize * vec2) * (1 / 5.1)
     vector = "%s,%s,0" % (vec1, vec2)
     es.setplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecBaseVelocity', vector)
    if srcpanel_bunnyjump_increase == 1:
     bunnyjump_increasesize = 0.2
     vec1 = es.getplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecVelocity[0]')
     vec2 = es.getplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecVelocity[1]')
     vec1 = (bunnyjump_increasesize * vec1) * (1 / 5.1)
     vec2 = (bunnyjump_increasesize * vec2) * (1 / 5.1)
     vector = "%s,%s,0" % (vec1, vec2)
     es.setplayerprop(ev['userid'], 'CBasePlayer.localdata.m_vecBaseVelocity', vector)


def round_start(ev):
    srcpanel_public_msg('is active on this server - by #default%s' %srcpanel_info.author)
    if srcpanel_bunnyjump_settings == 1:
      bhop_settings()


def round_end(ev):
    srcpanel_public_msg('- [www.srcpanel.webs.com]')


def es_map_start(ev):
    protect_sv_cheats()
    protect_sv_password()
    server_tickrate()


def bhop_settings():
      es.server.queue.cmd("sv_airaccelerate 1000")
      es.server.queue.cmd("sv_enablebunnyhopping 1")
      es.server.queue.cmd("sv_maxspeed 340")
      es.server.queue.cmd("sv_enableboost 1")


def protect_sv_cheats():
    if srcpanel_secure_sv_cheats == "1":
     protect_sv_cheats = es.server.queuecmd("sv_cheats 0")
     if not protect_sv_cheats == protect_sv_cheats:
      es.server.queuecmd("sv_cheats 0")


def protect_sv_password():
     if srcpanel_secure_password == "1":
      protect_sv_cheats = es.server.queuecmd("sv_password none")
     if not protect_sv_cheats == protect_sv_cheats:
      es.server.queuecmd("sv_password none")


